import javax.swing.*;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Toolkit;


public class GUI extends JFrame implements SwingConstants{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	JButton folderBtn;
	JButton startPack;
	
	JTextField folderTxt;
	JTextField jtPackName;
	
	JLabel jlBrowse;
	JLabel jlNrOfFiles;
	JLabel jlPackName;
	JLabel jlProgress;
	
	JSpinner jsNrOfFiles;
	SpinnerNumberModel  numberSpinner;
	
	JCheckBox cbListIncluded;
	JProgressBar progBar;
	//for the console
	JPanel consolePane;
	JTextArea console;
	JScrollPane scrollPane;
	String lastFolder;

	GUI(String title){
		super(title);
		String imgPath = new String(System.getProperty("user.dir") + "/www/crack&pack.jpg");
		setIconImage(Toolkit.getDefaultToolkit() 
				  .getImage(imgPath));
		lastFolder = System.getProperty("user.home");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setLayout(new GridBagLayout());
		init();
		
		
	}
	void init(){
		GridBagConstraints gbc = new GridBagConstraints();
		
		//labels
		jlBrowse = new JLabel("Path:"); 
		jlNrOfFiles = new JLabel("Max. number of files in archive:");
		jlPackName = new JLabel("ZIP package name:");
		jlProgress = new JLabel("Progress:");
		//textfield
		folderTxt = new JTextField(lastFolder);
		jtPackName = new JTextField("package");
		//buttons
		folderBtn = new JButton("Browse");
		folderBtn.addActionListener(new BtnActionListener());
		startPack = new JButton("Start Packing");
		startPack.addActionListener(new BtnActionListener());
		//spiner
		//create a JSpinner with current value / min /max /step size
		numberSpinner = new SpinnerNumberModel(10,1,65536,1);
		jsNrOfFiles =new JSpinner(numberSpinner);
		//checkbox
		cbListIncluded = new JCheckBox("Include a text file with zipped files!");
		cbListIncluded.setSelected(true);
		//progress bar
		progBar = new JProgressBar();
		progBar.setStringPainted(true);
		//for the console
		consolePane = new JPanel();
		consolePane.setLayout(new BorderLayout());
		console = new JTextArea(20,10);
		scrollPane = new JScrollPane(console);//,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
		        //JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		//user can't modify text in this console just read
		console.setEditable(false);
		console.setBackground(new Color(41,41,41));// some  gray to black
		console.setForeground(new Color(224,224,224)); //gray white
		consolePane.add(scrollPane);
	

		//layout
		gbc.gridx = 0; //starting column (horizontal) int
		gbc.gridy = 0; //starting row (vertical) int
		gbc.gridwidth = 5; //how many columns this item needs, int
		gbc.gridheight = 1; //how many rows this item needs, int
		gbc.weightx = 0; //indicates the capacity of cell to grow horizontal, double
		gbc.weighty = 0.5; //indicates the capacity of cell to grow vertical, double
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		add(jlBrowse,gbc);    
		
		gbc.gridx = 5; //starting column (horizontal) int
		gbc.gridy = 0; //starting row (vertical) int
		gbc.gridwidth = 10; //how many columns this item needs, int
		gbc.gridheight = 1; //how many rows this item needs, int
		gbc.weightx = 0; //indicates the capacity of cell to grow horizontal, double
		gbc.weighty = 0.5; //indicates the capacity of cell to grow vertical, double
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		add(folderTxt,gbc);
		
		gbc.gridx = 15; //starting column (horizontal) int
		gbc.gridy = 0; //starting row (vertical) int
		gbc.gridwidth = 5; //how many columns this item needs, int
		gbc.gridheight = 1; //how many rows this item needs, int
		gbc.weightx = 0; //indicates the capacity of cell to grow horizontal, double
		gbc.weighty = 0.5; //indicates the capacity of cell to grow vertical, double
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		add(folderBtn,gbc);
		
		gbc.gridx = 0; //starting column (horizontal) int
		gbc.gridy = 1; //starting row (vertical) int
		gbc.gridwidth = 5; //how many columns this item needs, int
		gbc.gridheight = 1; //how many rows this item needs, int
		gbc.weightx = 0; //indicates the capacity of cell to grow horizontal, double
		gbc.weighty = 0.5; //indicates the capacity of cell to grow vertical, double
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		add(jlNrOfFiles,gbc); 
		
		gbc.gridx = 5; //starting column (horizontal) int
		gbc.gridy = 1; //starting row (vertical) int
		gbc.gridwidth = 10; //how many columns this item needs, int
		gbc.gridheight = 1; //how many rows this item needs, int
		gbc.weightx = 0.5; //indicates the capacity of cell to grow horizontal, double
		gbc.weighty = 0.5; //indicates the capacity of cell to grow vertical, double
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		add(jsNrOfFiles,gbc); 
		
		gbc.gridx = 0; //starting column (horizontal) int
		gbc.gridy = 2; //starting row (vertical) int
		gbc.gridwidth = 20; //how many columns this item needs, int
		gbc.gridheight = 1; //how many rows this item needs, int
		gbc.weightx = 0.5; //indicates the capacity of cell to grow horizontal, double
		gbc.weighty = 0.5; //indicates the capacity of cell to grow vertical, double
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		add(cbListIncluded,gbc);
		
		gbc.gridx = 0; //starting column (horizontal) int
		gbc.gridy = 3; //starting row (vertical) int
		gbc.gridwidth = 5; //how many columns this item needs, int
		gbc.gridheight = 1; //how many rows this item needs, int
		gbc.weightx = 0; //indicates the capacity of cell to grow horizontal, double
		gbc.weighty = 0.5; //indicates the capacity of cell to grow vertical, double
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		add(jlPackName,gbc);
		
		gbc.gridx = 5; //starting column (horizontal) int
		gbc.gridy = 3; //starting row (vertical) int
		gbc.gridwidth = 10; //how many columns this item needs, int
		gbc.gridheight = 1; //how many rows this item needs, int
		gbc.weightx = 0.5; //indicates the capacity of cell to grow horizontal, double
		gbc.weighty = 0.5; //indicates the capacity of cell to grow vertical, double
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		add(jtPackName,gbc);  
		
		gbc.gridx = 15; //starting column (horizontal) int
		gbc.gridy = 3; //starting row (vertical) int
		gbc.gridwidth = 5; //how many columns this item needs, int
		gbc.gridheight = 1; //how many rows this item needs, int
		gbc.weightx = 0; //indicates the capacity of cell to grow horizontal, double
		gbc.weighty = 0.5; //indicates the capacity of cell to grow vertical, double
		add(startPack,gbc);
		
		gbc.gridx = 0; //starting column (horizontal) int
		gbc.gridy = 4; //starting row (vertical) int
		gbc.gridwidth = 20; //how many columns this item needs, int
		gbc.gridheight = 4; //how many rows this item needs, int
		gbc.weightx = 0; //indicates the capacity of cell to grow horizontal, double
		gbc.weighty = 0; //indicates the capacity of cell to grow vertical, double
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		add(consolePane,gbc);  
		
		gbc.gridx = 0; //starting column (horizontal) int
		gbc.gridy = 8; //starting row (vertical) int
		gbc.gridwidth = 5; //how many columns this item needs, int
		gbc.gridheight = 1; //how many rows this item needs, int
		gbc.weightx = 0; //indicates the capacity of cell to grow horizontal, double
		gbc.weighty = 0; //indicates the capacity of cell to grow vertical, double
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		add(jlProgress,gbc);  
		
		gbc.gridx = 5; //starting column (horizontal) int
		gbc.gridy = 8; //starting row (vertical) int
		gbc.gridwidth = 15; //how many columns this item needs, int
		gbc.gridheight = 1; //how many rows this item needs, int
		gbc.weightx = 1; //indicates the capacity of cell to grow horizontal, double
		gbc.weighty = 0.5; //indicates the capacity of cell to grow vertical, double
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		add(progBar,gbc);
		pack();
		setVisible(true);
	}
	
	class BtnActionListener implements ActionListener {

		@Override
		public void actionPerformed(ActionEvent e) {
			JButton button = (JButton)e.getSource();
			if(button == GUI.this.folderBtn){
				DirectoryChooser folderBrowse = new 
										DirectoryChooser(GUI.this,GUI.this.lastFolder,"Choose directory...");
			
				GUI.this.lastFolder = folderBrowse.getDirectory();
				GUI.this.folderTxt.setText(GUI.this.lastFolder);
			}
			else if(button == GUI.this.startPack){
				Zipper zipper = new Zipper(GUI.this.lastFolder,Integer.parseInt(GUI.this.jsNrOfFiles.getValue().toString()),GUI.this.cbListIncluded.isSelected());
				zipper.setPackageName(GUI.this.jtPackName.getText());
				zipper.setProgressBar(GUI.this.progBar);
				zipper.setConsole(GUI.this.console);
				zipper.start();
			}
		}
	}	
		
	}
