/**
 * 
 */

/**
 * @author faur
 *
 */
import java.awt.Font;
import java.io.*;
import java.util.zip.*;

import javax.swing.JProgressBar;
import javax.swing.JTextArea;

public class Zipper extends Thread{
	String path;
	String archName;
	String fileSeparator;
	int maxArchFiles;
	Boolean inclFileList;
	JProgressBar progressBar;
	JTextArea console;
	Zipper(String folder){
		path = folder;
		maxArchFiles = 10;
		inclFileList = true;
		archName = "package";
	}
	Zipper(String folder,int maxFiles){
		this(folder);
		maxArchFiles = maxFiles;
		fileSeparator = System.getProperty("file.separator");
	}
	Zipper(String folder,int maxFiles,Boolean includeList){
		this(folder,maxFiles);
		inclFileList = includeList;
	}
	public void setPackageName(String name){
		archName = name;
	}
	public void setProgressBar(JProgressBar progBar){
		progressBar = progBar;
	}
	public void setConsole(JTextArea cons){
		console = cons;
	}
	public void run(){
		byte[] data;
		int start = 0;
		int end = 0;
		int count = 0;
		int tmpCounter=0;
		int maxCounter =0;
		// get a list of files from current director
	    File[] files = new DirectoryList(path).listFiles();

	    //we need to pack a maxArchFiles into a zip file
	    if(progressBar != null){
	    	progressBar.setMinimum(0);
	    	progressBar.setMaximum(files.length);
	    }
	    if(console != null){
	    	console.setText("");
	    	console.setFont(new Font(null,Font.BOLD,14));
	    	console.append("Starting to write packages...\n");
	    	console.setFont(new Font(null,Font.PLAIN,11));
	    	
	    }
	    	try {
	    	while(tmpCounter <files.length ){	
	    		start = end;
	    		count++;	 
	    		String zipName = new String(path +fileSeparator+archName + Integer.toString(count)+ ".zip");
	    		FileOutputStream destination = new FileOutputStream(zipName);
	    		
				//this will compress data into a zip file
				ZipOutputStream out = new ZipOutputStream(new BufferedOutputStream(destination)); 
				//open the source data file as  file input stream ,create a zip entry for the given file
				//and add to the <destination>
				maxCounter = 0;
	    	while((maxCounter< maxArchFiles) && (tmpCounter <files.length)){
	    		tmpCounter++;
	    		maxCounter++;
					FileInputStream fi = new FileInputStream(files[tmpCounter-1]);
					data = new byte[(int) files[tmpCounter-1].length()];
					fi.read(data);
					ZipEntry ze = new ZipEntry(files[tmpCounter-1].getName());
					out.putNextEntry(ze);
					if(console != null){
						console.append("Writing:" + files[tmpCounter -1].getName() + "\n");
					}
					if(progressBar != null)
						progressBar.setValue(tmpCounter);
					out.write(data);
					fi.close();
	    	}
	    	end = tmpCounter;
				//if include a list with the files was checked than create that list and pack it
				//if not than let it be on the local directory
				BufferedWriter txtFl = new BufferedWriter(new FileWriter(path + fileSeparator + "listing"+ Integer.toString(count)+ ".txt"));
				for(int i = start;i<end;i++){
					txtFl.write(files[i].getName());
					txtFl.write("\n");
				}
				txtFl.close();
				int size = (int)new File(path + fileSeparator + "listing"+ Integer.toString(count)+ ".txt").length();
				if(inclFileList == true){
					FileInputStream fii = new FileInputStream(path + fileSeparator + "listing"+ Integer.toString(count)+ ".txt");
					//get the size of
					
					data = new byte[size];
					fii.read(data);
					ZipEntry ze = new ZipEntry("listing"+ Integer.toString(count)+ ".txt");
					out.putNextEntry(ze);
					out.write(data);
					fii.close();
				}
				
				out.close();
				
	    	}
			
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	}
	     

}
